#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#if (!$ENV{REQUEST_METHOD}) {     use CGI.pm    $input = new CGI; }

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use DBI;
use acs;
use htbuild;
use psfp;
use obbuild;

&get_setup;
$q = CGI->new;

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES

acs::check_access($username, $password, $q->param('username'), $q->param('password')); 

print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") {&show_options;} 
if ($q->param('fct') eq "start") {&start;} 

if ($q->param('fct') eq "get_category_ids_of_changed_links") {&get_category_ids_of_changed_links;} 
if ($q->param('fct') eq "build_changed_categories") {&build_changed_categories;} 
if ($q->param('fct') eq "analyze_whole_cats") {&analyze_whole_cats;} 
if ($q->param('fct') eq "analyze_part_cats") {&analyze_part_cats;} 
if ($q->param('fct') eq "analyze_changed_dirs") {&analyze_changed_dirs;} 
if ($q->param('fct') eq "do_building") {&do_building;} 
if ($q->param('fct') eq "do_frontpage") {&do_frontpage;} 
if ($q->param('fct') eq "do_newlinks") {&do_newlinks;} 
if ($q->param('fct') eq "do_tophits") {&do_tophits;} 
if ($q->param('fct') eq "do_category_includes") {&do_category_includes;} 
if ($q->param('fct') eq "do_total_link_include") {&do_total_link_include;} 
if ($q->param('fct') eq "do_keyword_includes") {&do_keyword_includes;} 




sub do_building
{
$gsettings = new_gsettings acs;


#### GET WEB BUILDING SETTINGS
$web_build = htbuild::get_file_contents2("$data_dir/web_build.cfg");
@wb_vars = split(/\n/, $web_build);
$wcats_per_build = $wb_vars[0];
$wait_web = $wb_vars[1];


$cpos = $q->param('cpos'); if ($cpos eq "") { $cpos = 0; }
$end_pos = $cpos + $wcats_per_build;

#print "555CURRENT POS = $cpos<BR>";
#print "555END POS = $end_pos<BR><BR>";


$cdatalines = &get_file_contents("$data_dir/changed_all.dat");  
@cdata = split (/\n/, $cdatalines);
$nr_lines = @cdata;

$ids = "";
$counter = 1;
$dc = 0;
foreach $item (@cdata)
	{
	if (($counter > $cpos) and ($counter <= $end_pos))
		{
		
			$dirstr_path = $item;
			$dirstr_path =~ s/-/\//g;
		
			my @catarr = split (/-/, $item);
			$level = @catarr;
			
			### CREATE DIRECTORIES IF NOT EXIST
			$dir_to_chk = "";
			foreach $cdir (@catarr)
				{
				$dir_to_chk = $dir_to_chk . $cdir . "/";
				
				if ((-e "$web_dir/$dir_to_chk") < 1) 
					{
					mkdir ("$web_dir/$dir_to_chk", $default_permissions);
					chmod($default_permissions,"$web_dir/$dir_to_chk","$web_dir/$dir_to_chk"); 					
					}
				
				$last_dir_name = $cdir;
				}
			

		### GET MORE PAGES NAME IF IN USE

		if ($gsettings->{category_page_names} eq "categorynames")
			{
				$last_dir_name = acs::decode_dir($last_dir_name);
				$dir_name = "";
				$tmp_name = lc($last_dir_name);
				$tmp_name =~ s/ /_/gi;
				for ($ms = 0; $ms < length($tmp_name); $ms++) 
				{
				$oneletter = substr($tmp_name, $ms, 1);
				if (($oneletter =~ /[0-9a-zA-Z]/) or ($oneletter eq "_"))
					{
					$dir_name = $dir_name . $oneletter;
					}
				}
			}
			else
			{
			$dir_name = "more";
			}
		
		###############
		
			
			
			### GET CATEGORY PAGE
			($newpage, $cpages, $curpage, $lnks_processed) = htbuild::get_cat($item, $level, "STATIC");
			$gen_default_index = $gsettings->{gen_default_index};

			$rtext = $rtext . "<br><b>/$dirstr_path/$gen_default_index</b><br>\n";
			
			open (CCP, ">> $data_dir/changed_rec.dat");
				print CCP "<BR><a href=\"$web_url/$dirstr_path/$gen_default_index\" target=\"_blank\"><b>/$dirstr_path/$gen_default_index</b></a><br>\n";
			close (CCP);
			
			### WRITE CATEGORY PAGE
			
			
			
			open (NEWP, "> $web_dir/$dirstr_path/$gen_default_index") or die "Cannot write $web_dir/$dirstr_path/$gen_default_index : $! - Likely related to file/directory permissions - Also check your disk space.";
				print NEWP $newpage;
			close (NEWP);
			chmod($default_permissions,"$web_dir/$dirstr_path/$gen_default_index","$web_dir/$dirstr_path/$gen_default_index");
		
			$pages_build++;
			

			if ($cpages > 1) ### BUILD 'MORE' PAGES
				{
				for ($ms1 = 2; $ms1 < ($cpages + 1); $ms1++)
					{
					$stw = ($gsettings->{nrlinks_per_page} * ($ms1 - 1));
					$ndw = ($gsettings->{nrlinks_per_page} * ($ms1 - 1)) + $gsettings->{nrlinks_per_page};
			
					($newpage, $cpages, $curpage, $lnks_processed) = htbuild::get_cat($item, $level, "STATIC", $stw, $ndw);
					$gen_default_index = $gsettings->{gen_default_index};
			
							$fname = "$web_dir/$dirstr_path/$dir_name" . "$ms1" . $gsettings->{gen_file_ext};
							$cfname = "/$dirstr_path/$dir_name" . "$ms1" . $gsettings->{gen_file_ext};
				
							$rtext = $rtext . "====> $cfname<br>\n";
				
							open (CCP, ">> $data_dir/changed_rec.dat");
								print CCP "====> <a href=\"" . $web_url . "$cfname\" target=\"_blank\"> $cfname</a><br>\n";
							close (CCP);
					
					open (NEWP2, "> $fname")  or die "Cannot open $fname : $! - Likely related to file/directory permissions - Also make sure you have enough disk space.";
						print NEWP2 $newpage;
					close (NEWP2);
					chmod($default_permissions,$fname,$fname);
					
					$pages_build++;
				}
	
			}
			

		}
	$counter++;
	}



if ($end_pos >= $nr_lines)
	{

### CLEAR TEMP FILES

$stat = unlink ("$data_dir/changed_all.dat"); 
$stat = unlink ("$data_dir/changed_cats.dat"); 
$stat = unlink ("$data_dir/changed_lnks.dat"); 
$stat = unlink ("$data_dir/changed_part.dat"); 
$stat = unlink ("$data_dir/changed_whole.dat"); 

$cdatalines = &get_file_contents("$data_dir/changed_rec.dat");  

if (length($cdatalines) < 5)
{

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Update Complete", qq[No files needed to be updated.]); 

print qq[

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
</body>
</html>
]; 

	
}
else
{

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Update Complete", qq[<b>HTML File Update Complete:</b><BR>$cdatalines]); 

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
</body>
</html>
];


}


$stat = unlink ("$data_dir/changed_rec.dat"); 

	}
else
	{

#print "FFFFIN";

if (($end_pos > 0) and ($nr_lines > 0))
	{
	$perc = ($end_pos / $nr_lines) * 100;
	$perc = sprintf("%5.2f",$perc); 
	}
	else
	{
	$perc = 1;
	}


$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Building...", qq[<b>Writing:</b><BR>$rtext]); 



print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="$wait_web;URL=$admin_url/genwebupd.cgi?fct=do_building&cpos=$end_pos">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
<body>

<table border="0" cellpadding="5" cellspacing="0" width="100%" style="border: 1px solid rgb(225,225,225)">
  <tr>
    <td width="12%"><strong><img src="$web_url/working.gif"></strong></td>
    <td width="12%"><p align="center"><strong>$perc % Complete</strong></td>
    <td width="88%">
     <table width="$perc%" border="0" cellpadding="6">
      <tr>
        <td height="25" background="$web_url/bar.gif">&nbsp;</td>
      </tr>
    </table>
    </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

$hbox

</head>
<body>
]; 
	
	}



}






sub analyze_changed_dirs
{

$cdatalines = &get_file_contents("$data_dir/changed_all.dat");  
@cdata = split (/\n/, $cdatalines);
@cdata = sort(@cdata);

	my %seen = (); 
	foreach $item (@cdata)
		{
		push(@uniq, $item) unless $seen{$item}++; 
		}

open (CC, "> $data_dir/changed_all.dat");
	foreach $item (@uniq)
		{
		print CC $item . "\n";
		}
close (CC);


$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[Analyzing changed categories that is to be built...]); 


print qq[

<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=do_building">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
<p><img src="$web_url/working.gif" width="270" height="36"></p>

$hbox


</body>
</html>
];

}






sub analyze_part_cats
{

$cpos = $q->param('cpos'); if ($cpos eq "") { $cpos = 0; }
$end_pos = $cpos + 5;

#print "111CURRENT POS = $cpos";
#print "111END POS = $end_pos";


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  



$cdatalines = &get_file_contents("$data_dir/changed_part.dat");  
@cdata = split (/\n/, $cdatalines);
$nr_lines = @cdata;

$ids = "";
$counter = 1;
$dc = 0;
foreach $item (@cdata)
	{
	if (($counter > $cpos) and ($counter <= $end_pos))
		{
				#############
				$sql = "SELECT * FROM dirs WHERE cid = '$item'";
				$sth = $dbh->prepare($sql);
				$sth->execute;
				
				while ( @row = $sth->fetchrow() )
					{
						$curdir = "";
						$displaydir = "";
						for ($ms = 2; $ms < 18; $ms++) 
							{
							if ($row[$ms] ne "")
								{
								$displaydir = $displaydir . $row[$ms] . "/";
								$curdir = $curdir . acs::encode_dir($row[$ms]) . "-";
								}
							} 
						
						$alldirs = $alldirs . substr($curdir, 0, length($curdir) - 1) . "\n";
						$current_analisis =$current_analisis . "--> $displaydir / ID: $item" . "<BR>";
					}
				##############

		}
	$counter++;
	}


if (defined($sth)){$sth->finish;}
$dbh->disconnect;


open (CHG, ">> $data_dir/changed_all.dat");
print CHG $alldirs;
close (CHG);


if ($end_pos >= $nr_lines)
	{

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[Analyzing changed categories that is to be built...]); 


print qq[

<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=analyze_changed_dirs">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />
</head>
<body>
<p><img src="$web_url/working.gif" width="270" height="36"></p>

$hbox

</body>
</html>

]; 


	}
else
	{
	
$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[Analyzing changed categories that is to be built...]); 


print qq[

<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=analyze_part_cats&cpos=$end_pos">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />
</head>
<body>

<p><img src="$web_url/working.gif" width="270" height="36"></p>

$hbox

</body>
</html>
]; 

	
	}




}




###########

sub analyze_whole_cats
{

$cpos = $q->param('cpos'); if ($cpos eq "") { $cpos = 0; }
$end_pos = $cpos + 5;

#print "CURRENT POS = $cpos";
#print "END POS = $end_pos";


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  



$cdatalines = &get_file_contents("$data_dir/changed_whole.dat");  
@cdata = split (/\n/, $cdatalines);
$nr_lines = @cdata;

$ids = "";
$counter = 1;
$dc = 0;
foreach $item (@cdata)
	{
	if (($counter > $cpos) and ($counter <= $end_pos))
		{
				#############
				$sql = "SELECT * FROM dirs WHERE cid = '$item'";
				$sth = $dbh->prepare($sql);
				$sth->execute;
				
				while ( @row = $sth->fetchrow() )
					{
						$curdir = "";
						$displaydir = "";
						for ($ms = 2; $ms < 18; $ms++) 
							{
							if ($row[$ms] ne "")
								{
								$displaydir = $displaydir . $row[$ms] . "/";
								$curdir = $curdir . acs::encode_dir($row[$ms]) . "-";
								$extdirs[$dc] = substr($curdir, 0, length($curdir) - 1);
								$dc++;
								}
							} 
						
						$current_analisis =$current_analisis . "--> $displaydir" . "<BR>";
					}
				##############

		}
	$counter++;
	}


if (defined($sth)){$sth->finish;}
$dbh->disconnect;




open (CHG, ">> $data_dir/changed_all.dat");
foreach $item (@extdirs)
	{
	print CHG $item . "\n";
	}
close (CHG);



if ($end_pos >= $nr_lines)
	{

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[Analyzing changed categories that is to be built...]); 

print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=analyze_part_cats">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
<p><img src="$web_url/working.gif" width="270" height="36"></p>

$hbox

</body>
</html>
];

	}
else
	{

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[Analyzing changed categories that is to be built... Please Wait...]); 

print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=analyze_whole_cats&cpos=$end_pos">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
<p><img src="$web_url/working.gif" width="270" height="36"></p>

$hbox

</body>
</html>
]; 
	
	}


}




sub build_changed_categories
{

$ldata = &get_file_contents("$data_dir/changed_cats.dat");  
@cat_lines = split (/\n/, $ldata);
@cat_lines = sort(@cat_lines);

### GET WHOLE LEVELS
$w_count = 0;
$i_count = 0;
foreach $item (@cat_lines)
	{
	($cid, $whole) = split (/:/, $item);
	if ($whole eq "LEVEL_WHOLE")
		{
		$whole_levels[$w_count] = $cid;
		$w_count++;
		}
		else
		{
		$indvidual_cats[$i_count] = $cid;
		$i_count++;
		}
	}


	### REMOVE DUPLICATES FROM WHOLE LEVELS
	my %seen = (); 
	foreach $item (@whole_levels)
		{
		push(@uniq_whole, $item) unless $seen{$item}++; 
		}


	### GET CID's OF WHOLE CATEGORIES TO BUILD
	open (WHL, "> $data_dir/changed_whole.dat");
	foreach $item (@uniq_whole)
		{
		print WHL $item . "\n";
		}
	close (WHL);


	### REMOVE DUPLICATES FROM PARTIAL LEVELS
	my %seen = (); 
	foreach $item (@indvidual_cats)
		{
		push(@uniq_part, $item) unless $seen{$item}++; 
		}

	@uniq_part = sort(@uniq_part);
	### GET CID's OF PARTIAL CATEGORIES TO BUILD
	open (WHL, "> $data_dir/changed_part.dat");
	foreach $item (@uniq_part)
		{
			print WHL $item . "\n";
		}
	close (WHL);


$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[Analyzing history of links that has changed...]); 

print qq[

<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=analyze_whole_cats">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
<body>

<p><img src="$web_url/working.gif" width="270" height="36"></p>

$hbox


</head>
<body>

]; 


}


sub do_keyword_includes
{

$new = $q->param('new');
$pop = $q->param('pop');
$catincl = $q->param('catincl');
$totalnk = $q->param('totalnk');
$popnewincl = $q->param('popnewincl');
$kewinc = $q->param('kewinc');


if ($kewinc eq "Y")
	{

$gsettings = new_gsettings acs;

$searchmeth = $gsettings->{searchmeth};

if ($searchmeth eq "pseek")
	{
	$searche_script = "$script_url/search.cgi";
	}
	else
	{
	$searche_script = "$script_url/search2.cgi";
	}

########### GET KEYWORD INCLUDES

$incls = acs::get_file_contents("$data_dir/kwincludes.dat"); 
@all_inc = split (/\n/, $incls);

$i_highnumber = 0;
foreach $item (@all_inc)
	{
	($ii_name, $ii_nr) = split (/\t/, $item);
	if ($ii_nr > $i_highnumber) { $i_highnumber = $ii_nr; }
	}


if ($i_highnumber > 0)
{

	########### FETCH KEYWORDS

	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 
	
	$sql = "SELECT keyword, COUNT(*) AS val FROM keywlog 
	GROUP BY keyword ORDER BY val DESC LIMIT $i_highnumber";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
	
	$ret_incl = "";
	$tmplname = "kwinc_" . $q->param('iname') . ".html";
	$incls2 = acs::get_file_contents("$data_dir/$tmplname"); 
	
	while ( @row = $sth->fetchrow() )
		{
		$tmp = push(@ARkeywords, $row[0] . "\t" . $row[1]);
		}

	$sth->finish;
	$dbh->disconnect;
	
	############ WRITE INCLUDE FILES
	
	foreach $kitem (@all_inc)
		{
		($ii_name, $ii_nr) = split (/\t/, $kitem);
		
			$tmplname = "kwinc_" . $ii_name . ".html";
			$incls2 = acs::get_file_contents("$data_dir/$tmplname"); 
			$include_to_write = "";
			
			for ($ms2 = 0; $ms2 < $ii_nr; $ms2++)
				{
				$kwtmp = $ARkeywords[$ms2];
				($realkw, $realkwnr) = split (/\t/, $kwtmp);
				
				$tmp_realkw = $realkw; $tmp_realkw =~ s/ /+/gi;
				$searche_script2 = $searche_script . "?keywords=$tmp_realkw";
				
				$tmplincl = $incls2;
				$tmplincl =~ s/!!keyword!!/$realkw/gi;
				$tmplincl =~ s/!!keyword_link!!/$searche_script2/gi;
				$tmplincl =~ s/!!nr!!/$realkwnr/gi;
				$include_to_write = $include_to_write . "$tmplincl";
				}
			
			if ($include_to_write ne "") ### WRITE INCLUDE
				{
				$include_to_write =~ s/\n/ /g;
				$ccrit = chr(10); $include_to_write =~ s/$ccrit/ /g;
				$ccrit = chr(13); $include_to_write =~ s/$ccrit/ /g;
				$include_to_write =~ s/'/\\'/g; 
				
				open (WDR, "> $web_dir/$ii_name.js");
					print WDR "function get_" . $ii_name . "()\n";
					print WDR "{\n";
					print WDR "document.write ('" . $include_to_write . "');\n";
					print WDR "}\n";
				close (WDR);
				
				chmod($default_permissions,"$web_dir/$ii_name.js","$web_dir/$ii_name.js");
				
				$toprint = $toprint . "<b>Written Top Search Term Include:</b> $web_dir/$ii_name.js<br>";
				
				}
		}
	
		
	} ### END OF HIGHNUMBER


if ($toprint eq "") { $toprint = "Please Wait..."; }

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[$toprint]); 


print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=get_category_ids_of_changed_links&new=$new&pop=$pop&catincl=$catincl&totalnk=$totalnk&popnewincl=$popnewincl&kewinc=$kewinc">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
<p><img src="$web_url/working.gif" width="270" height="36"></p>
$hbox

</body>
</html>
];

	
	}
	else
	{

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[Please Wait...]); 

print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=get_category_ids_of_changed_links&new=$new&pop=$pop&catincl=$catincl&totalnk=$totalnk&popnewincl=$popnewincl&kewinc=$kewinc">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
<p><img src="$web_url/working.gif" width="270" height="36"></p>
$hbox

</body>
</html>
];

	}


}





sub do_total_link_include
{

$new = $q->param('new');
$pop = $q->param('pop');
$catincl = $q->param('catincl');
$totalnk = $q->param('totalnk');
$popnewincl = $q->param('popnewincl');
$kewinc = $q->param('kewinc');

if ($totalnk eq "Y")
	{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

#------ calc dirs
$dir_sql = "SELECT COUNT(*) FROM dirs";
$sth = $dbh->prepare($dir_sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
while ( @row = $sth->fetchrow() ){$total_dirs = $row[0];}

#------ calc links

$link_sql = "SELECT COUNT(*) FROM links";
$sth = $dbh->prepare($link_sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
while ( @row = $sth->fetchrow() ){$total_links = $row[0];}

$sth->finish;
$dbh->disconnect;

# get file & replace var
$style_template = acs::get_file_contents("$data_dir/total_link.html");
$style_template =~ s/!!links!!/$total_links/g;
$style_template =~ s/!!dirs!!/$total_dirs/g;
#print "templ: $style_template";

# GENERATE final java / html 'include file'
$jname = "total_link"; #was $q->param('jname');
$fullpath = "$web_dir/$jname" . ".js";
$urlpath = "$web_url/$jname" . ".js";


$head_script = <<END_OF_HS;
<script SRC="$urlpath"></script>
END_OF_HS

$body_script = <<END_OF_BS;
<script LANGUAGE="JavaScript" TYPE="text/javascript">
<!--
get_$jname();
// -->
</script>
END_OF_BS

$style_template =~ s/\n/ /g;
$crit = chr(10); $style_template =~ s/$crit/ /g;
$crit = chr(13); $style_template =~ s/$crit/ /g;
$style_template =~ s/'/\\'/g;
# write html incl file AND JAVASCRIPT INCLUDE FILE
open (J_file, "> $fullpath"); # || acs::problem_popup
#("Couldn't write to file $fullpath :$! - Please ensure that the file has the permission setting of 777");
	#print J_file $style_template; #write content: [!!links!! !!dirs!!] eg. $allcats=generated categories;
	print J_file "function get_$jname()\n";
	print J_file "{\n";
	print J_file "document.write ('" . $style_template . "');\n";
	print J_file "}\n";
close (J_file);
$stat = chmod($default_permissions,"$fullpath","$fullpath");

$toprint = $toprint . "\n<B>Creating Total Link Include</B> - $total_links Links / $total_dirs Categories\n\n";


if ($toprint eq "") { $toprint = "Please Wait..."; }

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[$toprint]); 


print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=do_keyword_includes&new=$new&pop=$pop&catincl=$catincl&totalnk=$totalnk&popnewincl=$popnewincl&kewinc=$kewinc">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
<p><img src="$web_url/working.gif" width="270" height="36"></p>
$hbox

</body>
</html>
];

	}
	else
	{

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[Please Wait...]); 

print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=do_keyword_includes&new=$new&pop=$pop&catincl=$catincl&totalnk=$totalnk&popnewincl=$popnewincl&kewinc=$kewinc">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />
</head>
<body>
<p><img src="$web_url/working.gif" width="270" height="36"></p>
$hbox

</body>
</html>
];
	
	
	}
}




sub do_category_includes
{

$new = $q->param('new');
$pop = $q->param('pop');
$catincl = $q->param('catincl');
$totalnk = $q->param('totalnk');
$popnewincl = $q->param('popnewincl');
$kewinc = $q->param('kewinc');


if ($catincl eq "Y")
	{

opendir(DIR,"$data_dir");
@files = readdir(DIR);
@files = sort(@files);

foreach $filename (@files)
	{
	if (substr($filename, length($filename) - 4, 4) eq ".fpi")
		{
		$allcats = psfp::generate_categories("$filename");
		$allcats =~ s/\n/ /g;
		$crit = chr(10); $allcats =~ s/$crit/ /g;
		$crit = chr(13); $allcats =~ s/$crit/ /g;
		$allcats =~ s/'/\\'/g;
		
		$fullpath = "$web_dir/$filename";
		$fullpath =~ s/\.fpi/\.js/gi;
		$iname = $filename; $iname =~ s/\.fpi//gi; 
		
		open (FPS, "> $fullpath");
			print FPS "function get_$iname()\n";
			print FPS "{\n";
			print FPS "document.write ('" . $allcats . "');\n";
			print FPS "}\n";
		close (FPS);
		chmod($default_permissions,"$fullpath","$fullpath"); 
		
		$toprint = $toprint . "<b>Written Category Include:</b> $fullpath<br>";
	   }
	}


if ($toprint eq "") { $toprint = "Please Wait..."; }

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[$toprint]); 



print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=do_total_link_include&new=$new&pop=$pop&catincl=$catincl&totalnk=$totalnk&popnewincl=$popnewincl&kewinc=$kewinc">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
<p><img src="$web_url/working.gif" width="270" height="36"></p>
$hbox

</body>
</html>
];
	
	
	}
	else
	{

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[Please Wait...]); 

print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=do_total_link_include&new=$new&pop=$pop&catincl=$catincl&totalnk=$totalnk&popnewincl=$popnewincl&kewinc=$kewinc">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
<p><img src="$web_url/working.gif" width="270" height="36"></p>

$hbox

</body>
</html>
];
	
	
	
	}


}




sub do_tophits
{

$new = $q->param('new');
$pop = $q->param('pop');
$catincl = $q->param('catincl');
$totalnk = $q->param('totalnk');
$popnewincl = $q->param('popnewincl');
$kewinc = $q->param('kewinc');


if ($new eq "Y")
	{
	$gsettings = new_gsettings acs;

	$dfidx = $gsettings->{gen_default_index};

	($top_hits, $pop_cpages, $pop_curpage, $pop_lnks_processed) = htbuild::get_cat("", "", "STATIC", "", "", "pop");

		if ((-e "$web_dir/pop") < 1)
		{
		mkdir ("$web_dir/pop", $default_permissions);
		chmod($default_permissions,"$web_dir/pop","$web_dir/pop");
		}
			
		open (WNEW, "> $web_dir/pop/$dfidx") or die "Cannot open $web_dir/pop/$dfidx : $!";
			print WNEW $top_hits;
		close (WNEW);
		chmod($default_permissions,"$web_dir/pop/$dfidx","$web_dir/pop/$dfidx");


	$toprint = $toprint . "<b>Compiling 'Top Hits' Links'</b><br>";
	$toprint = $toprint . "/pop/$dfidx<br>";

	for ($ms1 = 2; $ms1 < ($pop_cpages + 1); $ms1++)
		{
					
		$stw = ($gsettings->{nrlinks_per_page} * ($ms1 - 1));
		$ndw = ($gsettings->{nrlinks_per_page} * ($ms1 - 1)) + $gsettings->{nrlinks_per_page};
			
		($newpage, $cpages, $curpage, $lnks_processed) = htbuild::get_cat("", $level, "STATIC", $stw, $ndw, "pop");

				$fname = "$web_dir/pop/" . "$ms1" . $gsettings->{gen_file_ext};
				$cfname = "/pop/" . "$ms1" . $gsettings->{gen_file_ext};
				
				$toprint = $toprint . "    =====> $cfname<br>";

			open (NEWP2, "> $fname")  or die "Cannot open $fname : $!";
				print NEWP2 $newpage;
			close (NEWP2);
			chmod($default_permissions,$fname,$fname);

			$pages_build++;
			$telnet_pages_build++;
			}


if ($toprint eq "") { $toprint = "Please Wait..."; }

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[$toprint]); 

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=do_category_includes&new=$new&pop=$pop&catincl=$catincl&totalnk=$totalnk&popnewincl=$popnewincl&kewinc=$kewinc">
</head>
<body>
<p><img src="$web_url/working.gif" width="270" height="36"></p>
$hbox
</body>
</html>
];



	}
	else
	{

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[Please Wait...]); 

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=do_category_includes&new=$new&pop=$pop&catincl=$catincl&totalnk=$totalnk&popnewincl=$popnewincl&kewinc=$kewinc">
</head>
<body>
<p><img src="$web_url/working.gif" width="270" height="36"></p>
$hbox
</body>
</html>
];

	
	
	}


}




sub do_newlinks
{

$new = $q->param('new');
$pop = $q->param('pop');
$catincl = $q->param('catincl');
$totalnk = $q->param('totalnk');
$popnewincl = $q->param('popnewincl');
$kewinc = $q->param('kewinc');

if ($new eq "Y")
	{
	$gsettings = new_gsettings acs;

	$dfidx = $gsettings->{gen_default_index};

	($whats_new, $new_cpages, $new_curpage, $new_lnks_processed) = htbuild::get_cat("", "", "STATIC", "", "", "new");
	
	if ((-e "$web_dir/new") < 1)
		{
		mkdir ("$web_dir/new", $default_permissions);
		chmod($default_permissions,"$web_dir/new","$web_dir/new");
		}
			
	open (WNEW, "> $web_dir/new/$dfidx")  or die "Cannot open $web_dir/new/$dfidx : $!";
		print WNEW $whats_new;
	close (WNEW);
	chmod($default_permissions,"$web_dir/new/$dfidx","$web_dir/new/$dfidx");

	$toprint = "<b>Compiling 'What's New Links'</b><br>";
	$toprint = $toprint . "/new/$dfidx<br>";


	for ($ms1 = 2; $ms1 < ($new_cpages + 1); $ms1++)
		{
				
		$stw = ($gsettings->{nrlinks_per_page} * ($ms1 - 1));
		$ndw = ($gsettings->{nrlinks_per_page} * ($ms1 - 1)) + $gsettings->{nrlinks_per_page};
		
		($newpage, $cpages, $curpage, $lnks_processed) = htbuild::get_cat("", $level, "STATIC", $stw, $ndw, "new");

				$fname = "$web_dir/new/" . "$ms1" . $gsettings->{gen_file_ext};
				$cfname = "/new/" . "$ms1" . $gsettings->{gen_file_ext};

				$toprint = $toprint .  "    =====> $cfname<br>";
		

			open (NEWP2, "> $fname")  or die "Cannot open $fname : $!";
				print NEWP2 $newpage;
			close (NEWP2);
			chmod($default_permissions,$fname,$fname);

			$pages_build++;
			$telnet_pages_build++;
			
		}



if ($toprint eq "") { $toprint = "Please Wait..."; }

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[$toprint]); 


print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=do_tophits&new=$new&pop=$pop&catincl=$catincl&totalnk=$totalnk&popnewincl=$popnewincl&kewinc=$kewinc">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
<p><img src="$web_url/working.gif" width="270" height="36"></p>
$hbox
</body>
</html>

];


	}
	else
	{

$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[Please Wait...]); 

print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=do_tophits&new=$new&pop=$pop&catincl=$catincl&totalnk=$totalnk&popnewincl=$popnewincl&kewinc=$kewinc">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
<p><img src="$web_url/working.gif" width="270" height="36"></p>
$hbox
</body>
</html>

];

	}



}





sub do_frontpage
{

$new = $q->param('new');
$pop = $q->param('pop');
$catincl = $q->param('catincl');
$totalnk = $q->param('totalnk');
$popnewincl = $q->param('popnewincl');
$kewinc = $q->param('kewinc');




$time = time();
$date = acs::decode_date($time);

open (TBUILD, "> $data_dir/fpgentime.dat") || acs::problem_popup("Could write to file $data_dir/fpgentime.dat :$! - Ensure that this file has the permission setting of 777.");
	print TBUILD $date;
close (TBUILD);
chmod($default_permissions,"$data_dir/fpgentime.dat","$data_dir/fpgentime.dat"); 

$allcats = psfp::generate_categories("fp_jscript.cfg");
$allcats =~ s/\n/ /g;
$crit = chr(10); $allcats =~ s/$crit/ /g;
$crit = chr(13); $allcats =~ s/$crit/ /g;
$allcats =~ s/'/\\'/g;


### WRITE JAVASCRIPT 

$script_to_write = qq[
	function get_categories()
	{
	document.write ('$allcats');
	}
];


$presc = qq[document.write('<script type="text/javascript" src="$web_url/categories2.js?' + (new Date()).getTime() + '"></script>');];

	open (SCRW, "> $web_dir/categories.js") || acs::problem_popup("Could not write to file $web_dir/categories.js :$!");
		print SCRW $presc;
	close (SCRW);
	$stat = chmod($default_permissions,"$web_dir/categories.js");

	open (SCRW, "> $web_dir/categories2.js") || acs::problem_popup("Could not write to file $web_dir/categories.js :$!");
		print SCRW $script_to_write;
	close (SCRW);
	$stat = chmod($default_permissions,"$web_dir/categories2.js");


### WRITE SSI

$allcats = psfp::generate_categories("fp_ssi.cfg");
$allcats =~ s/\n/ /g;
$crit = chr(10); $allcats =~ s/$crit/ /g;
$crit = chr(13); $allcats =~ s/$crit/ /g;

$fpsettings1 = acs::get_file_contents("$data_dir/fp_ssi.cfg");
if ($fpsettings1 eq "") { acs::get_file_contents("$data_dir/fp.cfg"); }
(@fp_settings1) = split (/\n/, $fpsettings1);


if ($fp_settings1[9] ne "")
	{
	open (IFILE, "> $fp_settings1[9]") || acs::problem_popup("Could not write to file $fp_settings1[9] :$! - Ensure that the server path you are using exists. If the path exists and is correct then the script may not have permission to write to this directory. <b>If you are not familiar with SSI then it would be best to use the JavaScript Include method for your front page. <a href=\"$admin_url/admin26.cgi?fct=settings\">click here to change the path where the include file is written to.</a></b>");
	 print IFILE $allcats;
	close (IFILE);
	$stat = chmod($default_permissions,"$fp_settings1[9]","$fp_settings1[9]");
	}



### WRITE IFRAME

$allcats = psfp::generate_categories("fp_iframe.cfg");
$allcats =~ s/\n/ /g;
$crit = chr(10); $allcats =~ s/$crit/ /g;
$crit = chr(13); $allcats =~ s/$crit/ /g;


	open (IFRMP, "> $web_dir/iframe_pg.html") || acs::problem_popup("Could not write to file $web_dir/iframe_pg.html :$!");
		print IFRMP $allcats;
	close (IFRMP);


### WRITE TEMPLATE FRONT PAGE

$fpwrite_file = acs::get_file_contents("$data_dir/fpwrite.dat");
if (length($fpwrite_file) < 2)
	{
	$fpwrite_file = "$web_dir/fp.html";
	}

$fphtml = acs::get_file_contents("$data_dir/psfp.html");
$fphtml =~ s/!!categories!!/$allcats/gi;
$fphtml = acs::ts_insert_template_includes($fphtml); 
$fphtml = acs::fill_vars($fphtml); 

open (FPW, "> $fpwrite_file");
	print FPW $fphtml;
close (FPW);



$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[Please Wait...]); 


print qq[

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/genwebupd.cgi?fct=do_newlinks&new=$new&pop=$pop&catincl=$catincl&totalnk=$totalnk&popnewincl=$popnewincl&kewinc=$kewinc">
</head>
<body>

<p><img src="$web_url/working.gif" width="270" height="36"></p>

$hbox

</body>
</html>


]; 



}





sub start
{

$new = $q->param('new');
$pop = $q->param('pop');
$catincl = $q->param('catincl');
$totalnk = $q->param('totalnk');
$popnewincl = $q->param('popnewincl');
$kewinc = $q->param('kewinc');

#<frame name="main" src="$admin_url/genwebupd.cgi?fct=get_category_ids_of_changed_links">

print <<END_OF_WB;

<html>
<head>
<title>PowerSeek</title>
</head>
<frameset framespacing="0" border="false" rows="105,*" frameborder="0">
  <frame name="header" scrolling="no" noresize target="main" src="$admin_url/generate.cgi?fct=get_top">
  <frame name="main" src="$admin_url/genwebupd.cgi?fct=do_frontpage&new=$new&pop=$pop&catincl=$catincl&totalnk=$totalnk&popnewincl=$popnewincl&kewinc=$kewinc">
  <noframes>
  <body>
  <p>This page uses frames, but your browser doesn't support them.</p>
  </body>
  </noframes>
</frameset>
</html>

END_OF_WB

}





sub get_category_ids_of_changed_links
{

### GET IDS

$ldata = &get_file_contents("$data_dir/changed_lnks.dat");  
@link_lines = split (/\n/, $ldata);

foreach $litem (@link_lines)
	{
	($link_id, $tmp) = split (/:/, $litem);
	if ($link_id ne "")
		{
		$where_sql = $where_sql . " (lnkid = '$link_id') OR";
		}
	}

$where_sql = substr($where_sql, 0, length($where_sql) - 2);


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$sql = "SELECT cid FROM links WHERE $where_sql GROUP BY cid";
$sth = $dbh->prepare($sql);
$sth->execute;
$erows = $sth->rows();
 
open (WF, ">> $data_dir/changed_cats.dat");
 
  while ( @row = $sth->fetchrow() )
	{ 
	print WF $row[0] . ":\n";
	}

close (WF);

$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_gen4.gif", "Working... ", qq[Analyzing history of links that has changed...]); 

print qq[

<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/genwebupd.cgi?fct=build_changed_categories">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>

<p><img src="$web_url/working.gif" width="270" height="36"></p>

$hbox

</body>
</html>

]; 


}




################################################################

sub show_options
{

$hbox = acs::get_heading_box("$web_url/ic_dirm.gif", "Update Generated HTML Files ", qq[Choose options below:]); 

print qq[

<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>

<body>


<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="53%" bgcolor="#0000A0"><img src="$web_url/htmlgen.jpg"> </td>
    <td width="47%" bgcolor="#0000A0" valign="top"><p align="center"></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
$hbox


<table border="0" cellpadding="0" cellspacing="1" width="100%" bgcolor="#DDDDDD">
  <tr>
    <td width="5%" bgcolor="#FFFFFF" align="center" valign="top"><img
    src="$web_url/ic_gen4.gif"> </td>
    <td width="95%" height="100" bgcolor="#FFFFFF"><table width="100%" border="0" cellpadding="6">
      <tr>
        <td><p class="normaltext"><strong>You have chosen to update your HTML
            files. Please read the notes below: </strong></p>
          <ul>
            <li><span class="normaltext">The option to update generated files will only update in the following situations: <br>
              &nbsp;
              </span>
              <ul>
                <li class="normaltext">When links have been edited/moved/copied/deleted. </li>
                <li class="normaltext">When links have been added manually by hand. </li>
                <li class="normaltext">When links have been approved/edited/moved/copied from the new submissions area. </li>
                <li class="normaltext">When categories have been added/edited/renamed or deleted. <br>
                  &nbsp; </li>
              </ul>
            </li>
            <li><span class="normaltext">You will want to re-generate everything in the following situations: <br>
              &nbsp;
              </span>
              <ul>
                <li class="normaltext">If you used any of the importers included with PowerSeek to import links. (ODP
                  importer/crawler/import utillity) </li>
                <li class="normaltext">If you used any third party application to import links into PowerSeek </li>
                <li class="normaltext">If you edited any PowerSeek template or any aspect of any template including custom
                  templates and template includes. </li>
                <li class="normaltext">If you assigned custom templates to categories </li>
                <li class="normaltext">If you changed banners that is to be rotated inside PowerSeek templates </li>
              </ul>
            </li>
          </ul>
          <p class="normaltext"><strong>Specify Options Below </strong></p>
          <form method="POST" action="$admin_url/genwebupd.cgi">
            <input type="hidden" name="fct" value="start">
            <div align="center">
              <center>
                <table
      border="0" cellpadding="5" cellspacing="0" width="100%">
                  <tr>
                    <td width="53%" class="normaltext">Update Front Page? </td>
                    <td width="47%" class="normaltext"><input type="checkbox" name="fp" value="Y" checked>                    </td>
                  </tr>
                  <tr>
                    <td width="53%" class="normaltext">Update What's New Pages? </td>
                    <td width="47%" class="normaltext"><input type="checkbox" name="new" value="Y" checked>                    </td>
                  </tr>
                  <tr>
                    <td width="53%" class="normaltext">Update Top hit's Pages? </td>
                    <td width="47%" class="normaltext"><input type="checkbox" name="pop" value="Y" checked>                    </td>
                  </tr>
                  <tr>
                    <td width="53%" class="normaltext">Update category includes? (if any) </td>
                    <td width="47%" class="normaltext"><input type="checkbox" name="catincl" value="Y" checked>                    </td>
                  </tr>
                  <tr>
                    <td width="53%" class="normaltext">Update total link include? (if in use) </td>
                    <td width="47%" class="normaltext"><input type="checkbox" name="totalnk" value="Y" checked>                    </td>
                  </tr>
                  <tr>
                    <td width="53%" class="normaltext">Update Popular &amp; New link includes? (if any) </td>
                    <td width="47%" class="normaltext"><input type="checkbox" name="popnewincl" value="Y" checked>                    </td>
                  </tr>
                  <tr>
                    <td width="53%" class="normaltext">Update Keyword Includes? (if any) </td>
                    <td width="47%" class="normaltext"><input type="checkbox" name="kewinc" value="Y" checked>                    </td>
                  </tr>
                  <tr>
                    <td width="53%"></td>
                    <td width="47%"><input type="submit" value="   Update   " name="B1">                    </td>
                  </tr>
                </table>
              </center>
            </div>
            </form>          </td>
      </tr>
    </table>
      </td>
  </tr>
</table>


<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>





</body>
</html>

];

}




####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

